Chuyển đến nội dung
Diễn đàn CADViet
PHAPLUONG

Nhờ Chỉnh Viết Lisp Copy Mtext Ra Nhiều Layout 1 Lần

Các bài được khuyến nghị

Em xin nhờ các bác viết giúp lisp với công dụng như sau:

1. Tạo Mtext trong layout đầu tiên

2. gõ lệnh ==> chọn Mtext thì tự động copy mtext đã tạo ra tất cả các layout còn lại với cùng toaj độ

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Lisp theo yêu cầu của bạn đây

 

(defun c:CopyToLayouts (/ *error* ss)

(princ "\rCOPYTOLAYOUTS ")

(vl-load-com)

 

(defun *error* (msg)

(if acDoc (vla-endundomark acDoc))

(cond ((not msg)) ; Normal exit

((member msg '("Function cancelled" "quit / exit abort"))) ; <esc> or (quit)

((princ (strcat "\n** Error: " msg " ** ")))) ; Fatal error, display it

(princ))

 

(prompt "\nSelect objects to copy to layouts: ")

(if (setq ss (ssget "_:L"))

((lambda (acDoc / oItemList oCurLayout)

(vla-startundomark acDoc)

(vlax-for oItem (setq ss (vla-get-activeselectionset acDoc))

(setq oItemList (cons oItem oItemList)))

(vlax-for oLayout (vla-get-layouts acDoc)

(if (and (/= (cond

(oCurLayout)

((setq oCurLayout (vla-get-activeLayout acDoc))))

oLayout)

(/= "Model" (vla-get-name oLayout)))

(vlax-invoke

acDoc

"copyobjects"

oItemList

(vla-get-block oLayout))))

(vla-delete ss)

(*error* nil))

(vla-get-activedocument (vlax-get-acad-object)))

(prompt "\n** Nothing selected ** "))

(princ))

  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tuyệt vời. Nhưng bác KangKung viết bằng "Vê lờ" nên hơi dài và bỏ qua Layer Lock. Dùng entmake gọn hơn:

(defun c:tt  (/ els mte i tab)
 (and (not (eq (strcase (setq tab (getvar 'CTAB))) "MODEL"))
      (setq mte (ssget '((0 . "MTEXT"))))
      (repeat (setq i (sslength mte))
       (setq els (entget (ssname mte (setq i (1- i)))))
       (foreach lay (vl-remove tab (layoutlist))
        (entmake (subst (cons 410 lay) (assoc 410 els) els)))))
 (princ))

  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tuyệt vời. Nhưng bác KangKung viết bằng "Vê lờ" nên hơi dài và bỏ qua Layer Lock. Dùng entmake gọn hơn:

(defun c:tt  (/ els mte i tab)

 (and (not (eq (strcase (setq tab (getvar 'CTAB))) "MODEL"))

      (setq mte (ssget '((0 . "MTEXT"))))

      (repeat (setq i (sslength mte))

       (setq els (entget (ssname mte (setq i (1- i)))))

       (foreach lay (vl-remove tab (layoutlist))

        (entmake (subst (cons 410 lay) (assoc 410 els) els)))))

 (princ))

Cảm ơn bác nhiệt tình giúp đỡ. Lisp của bác ngắn gọn mà đáp ứng đúng nhu cầu ban đầu của e là chỉ copy Mtext, còn lisp của bác @KhangKung thì có thể copy các đối tượng khác, vượt yêu cầu của e. Cảm ơn 2 bác

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

@Phapluong nếu sheet set của bạn mà có subset và bạn lấy fied title của sheet thì khi copy text các fiel này ko nhảy theo mà vẫn lấy theo giá trị đầu tiên khi tạo

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

@Phapluong nếu sheet set của bạn mà có subset và bạn lấy fied title của sheet thì khi copy text các fiel này ko nhảy theo mà vẫn lấy theo giá trị đầu tiên khi tạo

Mình thấy fiel vẫn nhảy theo sheet mà bạn

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay


×